% Copyright (C) 2003-2012 Julien Pommier.
%
% This file is a part of GETFEM++
%
% Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
% under  the  terms  of the  GNU  Lesser General Public License as published
% by  the  Free Software Foundation;  either version 3 of the License,  or
% (at your option) any later version along with the GCC Runtime Library
% Exception either version 3.1 or (at your option) any later version.
% This program  is  distributed  in  the  hope  that it will be useful,  but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
% License and GCC Runtime Library Exception for more details.
% You  should  have received a copy of the GNU Lesser General Public License
% along  with  this program;  if not, write to the Free Software Foundation,
% Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.

function asserterr(sx)
  global gverbose;
  global gdebug;

  % ASSERTERR DOES NOT WORK FOR ASSIGNMENTS (i.e. sx='x=1')
  % ONLY FOR EXPRESSIONS
  x = evalin('caller',sx, '[''catched'']');
  [LASTMSG, LASTID] = lasterr;
  if (~strcmp(x,'catched') | ...
      strfind(lasterr,'internal error') | ...
      strfind(lasterr,'Internal')),
    if (gverbose)
      dbstack;      
    end;
    if (gdebug)      
      disp(['Error triggering test failed:' sx]);
      keyboard;
    else
      error('AssertionFailed',['Error triggering test failed' sx]);
    end;
  elseif (strcmp(LASTID, 'MATLAB:m_assignments_do_not_produce_results')),
    disp('WRONG USE OF asserterr');
    dbstack
    keyboard
  end;
